"use strict";
exports.__esModule = true;
exports.ListMenu = exports.TypeMenu = exports.AlingMenu = exports.TabsMenu = void 0;
var tslib_1 = require("tslib");
var react_bootstrap_1 = require("react-bootstrap");
var slate_react_1 = require("slate-react");
var component_bootstrap_1 = require("@victorequena22/component-bootstrap");
require("bootstrap-icons/font/bootstrap-icons.css");
var react_1 = tslib_1.__importStar(require("react"));
var BlockUtils_1 = require("./BlockUtils");
//block menus
var TabsMenu = function (_a) {
    var _b = _a.left, left = _b === void 0 ? 2 : _b;
    var editor = (0, slate_react_1.useSlate)();
    var tabs = (0, BlockUtils_1.getTabs)(editor);
    return (react_1["default"].createElement(react_bootstrap_1.ButtonGroup, { className: "ml-".concat(left) },
        react_1["default"].createElement(component_bootstrap_1.ButtonConfig, { tip: 'TABULAR TEXTO A LA IZQUIERDA', icon: 'fas fa-angle-left', action: function () { return (0, BlockUtils_1.setTabs)(editor, tabs - 1); } }),
        react_1["default"].createElement(component_bootstrap_1.ButtonConfig, { tip: 'TABULAR TEXTO A LA DERECHA', icon: 'fas fa-angle-right', action: function () { return (0, BlockUtils_1.setTabs)(editor, tabs + 1); } })));
};
exports.TabsMenu = TabsMenu;
var AlingMenu = function (_a) {
    var _b = _a.left, left = _b === void 0 ? 2 : _b;
    var editor = (0, slate_react_1.useSlate)();
    var val = (0, react_1.useCallback)(function (e) { return (0, BlockUtils_1.isBlockProps)(editor, 'align', e); }, [editor]);
    var set = (0, react_1.useCallback)(function (e) { return (0, BlockUtils_1.setProps)(editor, 'align', e); }, [editor]);
    return (react_1["default"].createElement(react_bootstrap_1.ButtonGroup, { className: "ml-".concat(left) },
        react_1["default"].createElement(component_bootstrap_1.ButtonConfig, { tip: 'ALINEAR TEXTO A LA IZQUIERDA', icon: 'fas fa-align-left', active: val('left'), action: function () { return set('left'); } }),
        react_1["default"].createElement(component_bootstrap_1.ButtonConfig, { tip: 'CENTRAR TEXTO', icon: 'fas fa-align-center', active: val('center'), action: function () { return set('center'); } }),
        react_1["default"].createElement(component_bootstrap_1.ButtonConfig, { tip: 'ALINEAR TEXTO A LA DERECHA', icon: 'fas fa-align-right', active: val('right'), action: function () { return set('right'); } }),
        react_1["default"].createElement(component_bootstrap_1.ButtonConfig, { tip: 'JUSTIFICAR TEXTO', icon: 'fas fa-align-justify', active: val('justify'), action: function () { return set('justify'); } })));
};
exports.AlingMenu = AlingMenu;
var TypeMenu = function (_a) {
    var _b = _a.left, left = _b === void 0 ? 2 : _b;
    var editor = (0, slate_react_1.useSlate)();
    var val = (0, react_1.useCallback)(function (e) { return (0, BlockUtils_1.isBlockProps)(editor, 'type', e); }, [editor]);
    var set = (0, react_1.useCallback)(function (e) { return (0, BlockUtils_1.setPropsOrRemove)(editor, 'type', e); }, [editor]);
    return (react_1["default"].createElement(react_bootstrap_1.ButtonGroup, { className: "ml-".concat(left) },
        react_1["default"].createElement(component_bootstrap_1.ButtonConfig, { tip: 'TITULO 1', icon: 'fas fa-heading', active: val('heading-one'), action: function () { return set('heading-one'); } }),
        react_1["default"].createElement(component_bootstrap_1.ButtonConfig, { tip: 'TITULO 2', icon: 'fas fa-h1', active: val('heading-two'), action: function () { return set('heading-two'); } }),
        react_1["default"].createElement(component_bootstrap_1.ButtonConfig, { tip: 'TITULO 3', icon: 'fas fa-h2', active: val('heading-tre'), action: function () { return set('heading-tre'); } }),
        react_1["default"].createElement(component_bootstrap_1.ButtonConfig, { tip: 'TITULO 4', icon: 'fas fa-h3', active: val('heading-for'), action: function () { return set('heading-for'); } })));
};
exports.TypeMenu = TypeMenu;
var ListMenu = function (_a) {
    var _b = _a.left, left = _b === void 0 ? 2 : _b;
    var editor = (0, slate_react_1.useSlate)();
    var val = (0, react_1.useCallback)(function (e) { return (0, BlockUtils_1.isBlockProps)(editor, 'list', e); }, [editor]);
    var set = (0, react_1.useCallback)(function (e) { return (0, BlockUtils_1.setPropsOrRemove)(editor, 'list', e); }, [editor]);
    return (react_1["default"].createElement(react_bootstrap_1.ButtonGroup, { className: "ml-".concat(left) },
        react_1["default"].createElement(component_bootstrap_1.ButtonConfig, { tip: 'LISTA CON PUNTOS', icon: 'fas fa-list-ul', active: val('bulleted-list'), action: function () { return set('bulleted-list'); } }),
        react_1["default"].createElement(component_bootstrap_1.ButtonConfig, { tip: 'LISTA CON CUADROS', icon: 'fas fa-list', active: val('list-item'), action: function () { return set('list-item'); } })));
};
exports.ListMenu = ListMenu;
//# sourceMappingURL=BlockProps.js.map