"use strict";
exports.__esModule = true;
exports.useBlockProps = exports.getBlockProps = exports.isBlockProps = exports.setTabs = exports.getTabs = exports.getMatch = exports.setPropsOrRemove = exports.setProps = exports.getProp = void 0;
var slate_1 = require("slate");
require("bootstrap-icons/font/bootstrap-icons.css");
var slate_react_1 = require("slate-react");
var react_1 = require("react");
var getProp = function (n, prop) { return n[prop]; };
exports.getProp = getProp;
var setProps = function (editor, prop, value) {
    var _a;
    return slate_1.Transforms.setNodes(editor, (_a = {}, _a[prop] = value, _a));
};
exports.setProps = setProps;
var setPropsOrRemove = function (editor, prop, value) {
    var _a;
    return slate_1.Transforms.setNodes(editor, (_a = {}, _a[prop] = (0, exports.isBlockProps)(editor, prop, value) ? 'paragraph' : value, _a));
};
exports.setPropsOrRemove = setPropsOrRemove;
var getMatch = function (a, b) {
    var c = slate_1.Editor.nodes(a, b);
    return c;
};
exports.getMatch = getMatch;
var getTabs = function (editor) {
    for (var i = 0; i < 10; i++)
        if ((0, exports.isBlockProps)(editor, 'tabs', i))
            return i;
    return 0;
};
exports.getTabs = getTabs;
var setTabs = function (editor, i) { return (0, exports.setProps)(editor, 'tabs', i < 0 ? 0 : i > 9 ? 9 : i); };
exports.setTabs = setTabs;
var isBlockProps = function (editor, prop, value) {
    var selection = editor.selection;
    if (!selection)
        return false;
    var match = Array.from((0, exports.getMatch)(editor, {
        at: slate_1.Editor.unhangRange(editor, selection),
        match: function (n) { return !slate_1.Editor.isEditor(n) && slate_1.Element.isElement(n) && (0, exports.getProp)(n, prop) === value; }
    }))[0];
    return match && (match.length > 0);
};
exports.isBlockProps = isBlockProps;
var getBlockProps = function (editor, prop) {
    var selection = editor.selection;
    if (!selection)
        return false;
    var a = Array.from((0, exports.getMatch)(editor, {
        at: slate_1.Editor.unhangRange(editor, selection),
        match: function (n) { return !slate_1.Editor.isEditor(n) && slate_1.Element.isElement(n) && (0, exports.getProp)(n, prop); }
    }));
    if (a === undefined || a.length === 0 || a[0] === undefined || a[0].length === 0)
        return '';
    return a[0][0][prop];
};
exports.getBlockProps = getBlockProps;
var useBlockProps = function (props) {
    var editor = (0, slate_react_1.useSlate)();
    var v = (0, exports.getBlockProps)(editor, props);
    var s = (0, react_1.useCallback)(function (s) { return (0, exports.setProps)(editor, props, s); }, []);
    return [v, s];
};
exports.useBlockProps = useBlockProps;
//# sourceMappingURL=BlockUtils.js.map