"use strict";
exports.__esModule = true;
exports.hotKeysValue = void 0;
var tslib_1 = require("tslib");
var is_hotkey_1 = tslib_1.__importDefault(require("is-hotkey"));
var MarkProps_1 = require("./MarkProps");
var BlockUtils_1 = require("./BlockUtils");
var hotKeysMarks = {
    'ctrl+b': 'bold',
    'ctrl+i': 'italic',
    'ctrl+u': 'underline'
};
var hotKeyElement = {
    tab: 'indent',
    'shift+tab': 'outdent'
};
var hotKeysValue = function (editor, event) {
    for (var hotkey in hotKeysMarks) {
        if ((0, is_hotkey_1["default"])(hotkey, event)) {
            event.preventDefault();
            var mark = hotKeysMarks[hotkey];
            (0, MarkProps_1.toggleMark)(editor, mark);
        }
    }
    for (var hotkey in hotKeyElement) {
        if ((0, is_hotkey_1["default"])(hotkey, event)) {
            event.preventDefault();
            var props = hotKeyElement[hotkey];
            if (props === 'indent' || props === 'outdent') {
                var tab = (0, BlockUtils_1.getTabs)(editor);
                if (props === 'indent') {
                    (0, BlockUtils_1.setTabs)(editor, tab + 1);
                }
                else {
                    (0, BlockUtils_1.setTabs)(editor, tab - 1);
                }
            }
        }
    }
};
exports.hotKeysValue = hotKeysValue;
//# sourceMappingURL=HotKeys.js.map