"use strict";
exports.__esModule = true;
exports.TextToHTML = exports.Texto = exports.EditModal = void 0;
var tslib_1 = require("tslib");
var react_bootstrap_1 = require("react-bootstrap");
var slate_react_1 = require("slate-react");
var slate_1 = require("slate");
var react_1 = require("react");
var slate_history_1 = require("slate-history");
var Modal_1 = require("./Modal");
exports.EditModal = Modal_1.EditModal;
var BlockProps_1 = require("./BlockProps");
var Data_1 = require("./Data");
var Element_1 = require("./Element");
var Mark_1 = require("./Mark");
var MarkProps_1 = require("./MarkProps");
var HotKeys_1 = require("./HotKeys");
var Ver_1 = require("./Ver");
var react_2 = tslib_1.__importDefault(require("react"));
var Texto = function (_a) {
    var value = _a.value, onChange = _a.onChange, id = _a.id, colores = _a.colores, error = _a.error;
    var renderElement = (0, react_1.useCallback)(function (props) { return react_2["default"].createElement(Element_1.Element, tslib_1.__assign({}, props)); }, []);
    var renderLeaf = (0, react_1.useCallback)(function (props) { return react_2["default"].createElement(Mark_1.Leaf, tslib_1.__assign({}, props)); }, []);
    var editor = (0, react_1.useMemo)(function () { return (0, slate_history_1.withHistory)((0, slate_react_1.withReact)((0, slate_1.createEditor)())); }, []);
    var _b = (0, react_1.useState)(value.length ? (0, Data_1.setText)(value) : Data_1.defaultBlock), text = _b[0], setText = _b[1];
    var _c = (0, react_1.useState)(false), up = _c[0], setUP = _c[1];
    var setHtml = (0, react_1.useCallback)(function () { return onChange((0, Data_1.getText)(text)); }, [text, onChange]);
    (0, react_1.useEffect)(function () { setTimeout(function () { return setUP(!up); }, 1); }, [text]);
    (0, react_1.useEffect)(function () { return setHtml(); }, [up]);
    return react_2["default"].createElement(slate_react_1.Slate, { editor: editor, value: text, onChange: setText },
        react_2["default"].createElement(react_bootstrap_1.Col, { className: 'd-flex', xs: 12 },
            react_2["default"].createElement(MarkProps_1.MarkMenu, null),
            react_2["default"].createElement(MarkProps_1.ColorButton, { colores: colores }),
            react_2["default"].createElement(MarkProps_1.BackButton, { colores: colores }),
            react_2["default"].createElement(BlockProps_1.AlingMenu, null),
            react_2["default"].createElement(BlockProps_1.TabsMenu, null),
            react_2["default"].createElement(BlockProps_1.ListMenu, null),
            react_2["default"].createElement(BlockProps_1.TypeMenu, null),
            react_2["default"].createElement(MarkProps_1.FontStyle, null)),
        react_2["default"].createElement(react_bootstrap_1.Col, { xs: 12, className: 'mt-1' },
            error ? react_2["default"].createElement("small", { style: { color: '#dc3545' } }, error) : react_2["default"].createElement(react_2["default"].Fragment, null),
            react_2["default"].createElement(slate_react_1.Editable, { id: 'slate' + id, key: '' + Math.random(), spellCheck: true, renderElement: renderElement, renderLeaf: renderLeaf, onKeyDown: function (event) { return (0, HotKeys_1.hotKeysValue)(editor, event); }, style: {
                    padding: '.5rem .5rem .5rem .5rem', width: '100%', minWidth: '100px', maxHeight: '70vh',
                    border: error ? 'solid 1px #dc3545' : 'solid 1px #ced4da', overflowX: 'hidden',
                    minHeight: '30px', overflowY: 'auto', borderRadius: '.25rem'
                } })));
};
exports.Texto = Texto;
function TextToHTML(_a) {
    var text = _a.text;
    return react_2["default"].createElement(react_2["default"].Fragment, null, text.map(function (e) { return (react_2["default"].createElement(Ver_1.VerElement, { key: JSON.stringify(e), element: e }, e.children.map(function (a) { return (react_2["default"].createElement(Ver_1.VerLeaf, { key: a.text, leaf: a })); }))); }));
}
exports.TextToHTML = TextToHTML;
//# sourceMappingURL=Main.js.map