import { Editor, Transforms, Element as SlateElement } from 'slate';
import 'bootstrap-icons/font/bootstrap-icons.css';
import { useSlate } from 'slate-react';
import { useCallback } from 'react';
export var getProp = function (n, prop) { return n[prop]; };
export var setProps = function (editor, prop, value) {
    var _a;
    return Transforms.setNodes(editor, (_a = {}, _a[prop] = value, _a));
};
export var setPropsOrRemove = function (editor, prop, value) {
    var _a;
    return Transforms.setNodes(editor, (_a = {}, _a[prop] = isBlockProps(editor, prop, value) ? 'paragraph' : value, _a));
};
export var getMatch = function (a, b) {
    var c = Editor.nodes(a, b);
    return c;
};
export var getTabs = function (editor) {
    for (var i = 0; i < 10; i++)
        if (isBlockProps(editor, 'tabs', i))
            return i;
    return 0;
};
export var setTabs = function (editor, i) { return setProps(editor, 'tabs', i < 0 ? 0 : i > 9 ? 9 : i); };
export var isBlockProps = function (editor, prop, value) {
    var selection = editor.selection;
    if (!selection)
        return false;
    var match = Array.from(getMatch(editor, {
        at: Editor.unhangRange(editor, selection),
        match: function (n) { return !Editor.isEditor(n) && SlateElement.isElement(n) && getProp(n, prop) === value; }
    }))[0];
    return match && (match.length > 0);
};
export var getBlockProps = function (editor, prop) {
    var selection = editor.selection;
    if (!selection)
        return false;
    var a = Array.from(getMatch(editor, {
        at: Editor.unhangRange(editor, selection),
        match: function (n) { return !Editor.isEditor(n) && SlateElement.isElement(n) && getProp(n, prop); }
    }));
    if (a === undefined || a.length === 0 || a[0] === undefined || a[0].length === 0)
        return '';
    return a[0][0][prop];
};
export var useBlockProps = function (props) {
    var editor = useSlate();
    var v = getBlockProps(editor, props);
    var s = useCallback(function (s) { return setProps(editor, props, s); }, []);
    return [v, s];
};
//# sourceMappingURL=BlockUtils.js.map