import { __assign } from "tslib";
import React from 'react';
export var VerLeaf = function (_a) {
    var leaf = _a.leaf;
    var color = leaf.color, backgroundColor = leaf.backgroundColor, fontFamily = leaf.fontFamily, fontSize = leaf.fontSize, bold = leaf.bold, italic = leaf.italic, underline = leaf.underline, text = leaf.text;
    var style = {
        color: color,
        fontFamily: fontFamily,
        backgroundColor: backgroundColor,
        fontSize: fontSize ? "".concat(fontSize / 10, "rem") : undefined,
        fontWeight: bold ? 'bold' : 'normal',
        fontStyle: italic ? 'italic' : 'normal',
        textDecoration: underline ? 'underline' : 'none'
    };
    return React.createElement("span", { style: style, dangerouslySetInnerHTML: { __html: text.replaceAll('¤', '"') } });
};
export var VerElement = function (p) { return React.createElement(List, __assign({}, p)); };
var List = function (p) {
    var children = p.children, element = p.element;
    return React.createElement(Block, { element: element },
        React.createElement(ListElement, { element: element }, children));
};
var Block = function (_a) {
    var element = _a.element, children = _a.children;
    switch (element.type) {
        case 'heading-one':
            return React.createElement("h1", { style: getCSS(element) }, children);
        case 'heading-two':
            return React.createElement("h2", { style: getCSS(element) }, children);
        case 'heading-tre':
            return React.createElement("h3", { style: getCSS(element) }, children);
        case 'heading-for':
            return React.createElement("h4", { style: getCSS(element) }, children);
        default:
            return React.createElement("p", { style: getCSS(element) }, children);
    }
};
export function TextToHTML(_a) {
    var text = _a.text;
    return React.createElement(React.Fragment, null, text.map(function (e) { return (React.createElement(VerElement, { key: JSON.stringify(e), element: e }, e.children.map(function (a) { return (React.createElement(VerLeaf, { key: a.text, leaf: a })); }))); }));
}
var getCSS = function (_a) {
    var align = _a.align, tabs = _a.tabs, type = _a.type, children = _a.children;
    var font = getFontUsa(type, children[0]) / 10;
    var t2 = tabs * 2;
    var color = children[0] ? children[0].color : '#000';
    return {
        float: 'right', textAlign: align, padding: '0 0 0 0', fontSize: "".concat(font, "rem"), minHeight: "".concat(font, "rem"),
        width: "calc(100% - ".concat(t2, "rem)"), margin: '.05rem .05rem .05rem .05rem',
        color: color,
        display: 'flex',
        justifyContent: align
    };
};
var getFontSize = function (type) {
    if (type === 'heading-one')
        return 26;
    if (type === 'heading-two')
        return 22;
    if (type === 'heading-tre')
        return 18;
    if (type === 'heading-for')
        return 14;
    return 10;
};
var getFontUsa = function (type, children) {
    var b = getFontSize(type);
    var c = children === null || children === void 0 ? void 0 : children.fontSize;
    if (c)
        return c < b ? b : c;
    return b;
};
var ListElement = function (_a) {
    var element = _a.element, children = _a.children;
    var list = element.list;
    return list === 'paragraph' ? React.createElement("div", { style: getCSSNoList(element) }, children) : React.createElement("div", { style: getCSSList(element) }, children);
};
var getCSSList = function (_a) {
    var tabs = _a.tabs, type = _a.type, list = _a.list, children = _a.children, align = _a.align;
    var font = getFontUsa(type, children[0]) / 10;
    var t2 = tabs * 2;
    var t = list === 'paragraph' ? t2 : t2 + font;
    var s = list === 'paragraph' ? {} : { display: 'list-item', listStyleType: list === 'bulleted-list' ? 'disc' : 'square' };
    return __assign(__assign({ padding: '0 0 0 0', width: "fit-content" }, s), { marginLeft: "".concat(t, "rem"), textAlign: align });
};
var getCSSNoList = function (_a) {
    var align = _a.align;
    return {
        padding: '0 0 0 0', width: "fit-content", textAlign: align
    };
};
//# sourceMappingURL=Ver.js.map